package mmj;

import java.util.*;
import java.awt.Image;
import java.awt.Color;

public class Environment {
  Expression first;

  Hashtable variable = new Hashtable();
  Hashtable label = new Hashtable();
  Stack stack = new Stack();
  Vector point = new Vector();
  long tstart, tadd;
  int freq = 6000;

  boolean key[], opt1[][];
  int opt2[];

  public Environment() {
	key = new boolean[MMJKey.KEY_COUNT];

	opt1 = new boolean['z' -'a' +1]['z' -'a' +2];
	for (int i=0; i<opt1.length; i++)
	  for (int j=0; j<opt1[i].length; j++)
		opt1[i][j] = false;

	opt2 = new int['z' -'a' +1];
	for (int i=0; i<opt2.length; i++)
	  opt2[i] = 0;
  }
  public void init() {
	for (int i=0; i<key.length; i++)
	  key[i] = false;
	variable.clear();
	stack = new Stack();
	clearTimeCount();
  }

  public void setFirstExpression(Expression e) {
    first = e;
  }
  public Expression getFirstExpression() {
    return first;
  }

  public void setVariable(Object key, int v) {
	variable.put(key, new Integer(v));
  }
  public int getVariable(Object key) {
	return(variable.containsKey(key)
		   ? ((Integer) variable.get(key)).intValue()
		   : 0);
  }
  public void setVariable(int i, int v) {
	setVariable(new Integer(i), v);
  }
  public int getVariable(int i) {
	return(getVariable(new Integer(i)));
  }

  public void setLabel(int l, Expression e) {
	label.put(new Integer(l), e);
  }
  public Expression getLabel(int l) {
	return((Expression)label.get(new Integer(l)));
  }

  public void push(Expression e) {
	stack.push(e);
  }
  public Expression pop() throws EmptyStackException {
	return((Expression) stack.pop());
  }

  public void point(int i) {
	Integer p = new Integer(i);
	if (! point.contains(p)) point.addElement(p);
  }
  public int[] getPointedNumber() {
	int ret[] = new int[point.size()];
	for (int i=0; i<ret.length; i++)
	  ret[i] = ((Integer) point.elementAt(i)).intValue();
	return(ret);
  }

  public boolean getKey(int k) {
	if (k == MMJKey.VK_ALL) {
	  synchronized (this) {
		for (int i=0; i<key.length; i++)
		  if (key[i]) return(true);
		return(false);
	  }
	} else {
      return(key[k]);
	}
  }
  public synchronized void setKey(int k, boolean b) {
	key[k] = b;
  }

  public synchronized void setOption2(int i, int v) {
	opt2[i] = v;
  }
  public int getOption2(int i) {
	return(opt2[i]);
  }

  public synchronized void setOption1(int i, boolean b) {
	opt1[i]['z' - 'a' +1] = b;
  }
  public synchronized void setOption1(int i, int j, boolean b) {
	opt1[i][j] = b;
  }
  public boolean getOption1(int i) {
	synchronized (this) {
	  for (int j=0; j<opt1[i].length; j++)
		if (opt1[i][j]) return true;
	  return false;
	}
  }
  public boolean getOption1(int i, int j) {
	return(opt1[i][j]);
  }

  public void clearTimeCount() {
	tstart = System.currentTimeMillis();
	tadd = 0;
  }
  public void pauseTimeCount() {
	tadd += System.currentTimeMillis() - tstart;
  }
  public void continueTimeCount() {
	tstart = System.currentTimeMillis();
  }
  public void setFrequency(int f) {
	freq = f;
  }
  public int getTimeCount() {
	long current = System.currentTimeMillis();
	return((int) ((current - tstart + tadd)*freq /1000 / 100));
  }
  public void waitTo(int w) {
	int t;
	while ((t=getTimeCount()) < w) {
	  try {
		/*
		  count = sec * freq / 100;
		  if you want to wait x[count]:
		  x = t * freq/100 <=> t = x*100/freq [sec].
		  */
		long l = (w-t) * 100 * 1000 / freq;

		/*
long x = System.currentTimeMillis() - tstart + tadd;
System.out.println("[msec]:    " + x);
System.out.println("frequency: " +freq );
System.out.println("timecount: " + t);
System.out.println("wait for:  " + w);
System.out.println("result:    " + l);
*/
		Thread.currentThread().sleep(l +10);
	  } catch (InterruptedException e) {
	  }
	}
  }
}
