package mmj.main;

import mmj.util.PackFrame;
import mmj.*;
import mmj.mmasl.*;
import mmj.mmasl.msc.MSC;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

public class Future {
  Environment env;

  public Future(InputStream is) throws Exception {
	MMS mms = new MMS(is);
	mms.fileread();

	env = mms.getEnvironment();
	/*
	MSC msc = new MSC(is);
	Environment env = msc.compile();
	*/
	Executer exec = new Executer(env);
	exec.setPalette(mms.getPALs()[0]);

	NAKExpander exp = new NAKExpander(mms);
	exp.run();
	Image[][] image = exp.getImages();
	for (int i=0; i<image.length; i++) {
	  exec.setImage(i, image[i][0]);
	  exec.setImageMove(i, exp.getPoint(i));
	}

	Frame rf = new PackFrame();
	rf.add(exec.getRealCanvas(), "Center");
	rf.pack();
	rf.show();

	KeyListener lsn = new KeyAdapter() {
	  public void keyPressed(KeyEvent ev) {
		int i = MMJKey.convertAWTtoMM(ev.getKeyCode());
		if (i != MMJKey.VK_OTHER)
		  env.setKey(i, true);
	  }
	  public void keyReleased(KeyEvent ev) {
		int i = MMJKey.convertAWTtoMM(ev.getKeyCode());
		if (i != MMJKey.VK_OTHER)
		  env.setKey(i, false);
	  }
	};
	exec.getRealCanvas().addKeyListener(lsn);
	rf.addKeyListener(lsn);

	Frame vf = new Frame();
	vf.add(exec.getVirtualCanvas(), "Center");
	vf.pack();
	vf.show();

	Frame ff = new Frame();
	Component ctrl = new StepExecuter(exec,
									  env.getFirstExpression().getSource());
	ff.add(ctrl, "Center");
	ff.pack();
	ff.show();
  }


  public static final void main(String args[]) throws Exception {
	String file = null;
	for (int i=0; i<args.length; i++) {
	  if (args[i].charAt(0) == '-') {
		if (args[i].length() > 2) {
		  switch (args[i].charAt(1)) {
		  case 'd': NAKExpander.setDebugLevel(1);
		  }
		}
	  } else {
		file = args[i];
		break;
	  }
	}
	if (file == null) {
	  System.out.println("java Future [opt] <filename>");
	  return;
	}

	InputStream is = new FileInputStream(args[0]);
	//	is = new Tee(is);
	new Future(is);
  }
}
