package mmj.main;

import mmj.util.PackFrame;
import mmj.util.Extension;
import mmj.*;
import mmj.mmasl.*;
import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

public class MMJ extends Applet implements NAKObserver {
  static final Extension extension = new Extension(".mms");
  Environment env;
  Executer exec;
  MMS mms;

  public MMJ() { }
  public void init() {
	try {
	  String file = getParameter("file");
	  InputStream is = new BufferedInputStream(extension.fromURL(this,file));
	  load(is);
	  add();
	  expand();
	} catch (Exception e) {
	  e.printStackTrace();
	}
  }
  public static final void main(String args[]) throws Exception {
	String file = null;
	for (int i=0; i<args.length; i++) {
	  if (args[i].charAt(0) == '-') {
		if (2 <= args[i].length()) {
		  switch (args[i].charAt(1)) {
		  case 'd': NAKExpander.setDebugLevel(1);
		  }
		}
	  } else {
		file = args[i];
		break;
	  }
	}
	if (file == null) {
	  System.out.println("java Test [opt] <filename>");
	  return;
	}
	//	InputStream is = new FileInputStream(file);
	InputStream is = new BufferedInputStream(extension.fromFile(file));

	MMJ mmj = new MMJ();
	mmj.load(is);
	mmj.add();

	PackFrame f = new PackFrame();
	f.setTitle("MMJ");
	f.add(mmj, "Center");
	mmj.exec.getRealCanvas().addComponentListener(f);
	f.pack();
	f.show();

	mmj.expand();
	mmj.start();
  }

  public void start() {
	if (exec != null) {
	  exec.execute();
	}
  }
  public void stop() {
	if (exec != null) {
	  exec.stop();
	}
  }

  public void NAKUpdate(int current, int count, int all, NAKExpander e) {
	String s = "" + count + "/" + all;
	try {
	  getAppletContext().showStatus(s);
	} catch (NullPointerException ex) {
	  //	  System.out.println(s);
	}
  }
  public void death(Throwable t) {
	t.printStackTrace();
	stop();
  }


  private void add() {
	KeyListener lsn = new KeyAdapter() {
	  public void keyPressed(KeyEvent ev) {
		int i = MMJKey.convertAWTtoMM(ev.getKeyCode());
		if (i != MMJKey.VK_OTHER)
		  env.setKey(i, true);
	  }
	  public void keyReleased(KeyEvent ev) {
		int i = MMJKey.convertAWTtoMM(ev.getKeyCode());
		if (i != MMJKey.VK_OTHER)
		  env.setKey(i, false);
	  }
	};
	exec.getRealCanvas().addKeyListener(lsn);
	this.addMouseListener(new MouseAdapter() {
	  public void mouseEntered(MouseEvent ev) {
		if (exec != null && exec.getRealCanvas() != null)
		  exec.getRealCanvas().requestFocus();
	  }
	});

	add(exec.getRealCanvas(), "Center");
	setBackground(exec.getRealCanvas().getBackground());
	setVisible(true);
	exec.getRealCanvas().requestFocus();
  }
  private void load(InputStream is) throws Exception {
	mms = new MMS(is);
	mms.fileread();
	env = mms.getEnvironment();

	exec = new Executer(env);
	exec.setPalette(mms.getPALs()[0]);
  }

  private void expand() throws Exception {
	NAKExpander exp = new NAKExpander(mms);
	exp.addObserver(this);

	exp.run();
	Image[][] image = exp.getImages();
	for (int i=0; i<image.length; i++) {
	  exec.setImage(i, image[i][0]);
	  exec.setImageMove(i, exp.getPoint(i));
	}
  }
}
