package mmj.mmasl;

import mmj.Environment;
import mmj.mmasl.msc.MSC;
import mmj.mmasl.msc.ParseException;
import java.awt.*;
import java.awt.image.*;
import java.util.*;
import java.io.*;

public class MMS {
  MMInputStream is;
  ColorModel cm;

  String comment = "";
  Environment env;

  //  ComPoints cp;
  NAK nak[];
  ColorModel pal[];
  /*
  PKN pkn[];
  */
  int ver;

  public MMS(InputStream is) {
	if (is instanceof MMInputStream) {
	  this.is = (MMInputStream)is;
	} else {
	  if (is instanceof BufferedInputStream) {
		this.is = new MMInputStream(is);
	  } else {
		this.is = new MMInputStream(new BufferedInputStream(is));
	  }
	}
  }
  /*
  Vector mmjpoint;
  public void setMMJPoint(Vector v) {
	mmjpoint = v;
  }
  */
  
  public void fileread() throws IllegalMSCFormatException , IOException {
	//Vector files = new Vector();
	int files = 0;
	Vector vnak, vpal, vpkn;
	
	vnak = new Vector();
	vpal = new Vector();
	vpkn = new Vector();
	
	byte buf[] = new byte[48];
	for (int i=0; i<48; i++)
	  buf[i] = 0;	
	
	try {
	  is.read(buf, 0, 8);
	  if (buf[0] != 'M' && buf[1] != 'M' && buf[2] != 'S') {
		throw(new IllegalMSCFormatException("bad header"));
	  }
	  
	  {						// MMASL
		int waittime;
		int size = is.get16();
		
		byte b[] = new byte[size];
		is.read(b);
		int p=0;
		if (b[p] != 'M' || b[p+1] != 'M' || 
			b[p+2] != 'A' || b[p+3] != 'S' || b[p+4] != 'L') {
		  throw(new IllegalMSCFormatException("bad MMASL header"));
		}
		p+=5;
		while (b[p] < '0' || '9' < b[p])
		  p++;
		{
		  ver = 0;
		  while (b[p] != '.') {
			ver = ver *10 + (b[p++] - '0');
		  }
		  ver *= 10000;
		  p++;
		  int i = 1000;
		  while ('0' <= b[p] && b[p] <= '9') {
			ver += (b[p++] - '0') *i;
			i /= 10;
		  }
		  /*
		  if (ver > 11000) {
			String sv = "" + ver/10000 + "." + ver%10000;
			throw(new IllegalMSCFormatException(
					 "Ver " + sv + "is not supported."));
		  }
		  */
		} 
		while (b[p-2] != 0x0d || b[p-1] != 0x0a)
		  p++;
		{
		  int off = p;
		  while (b[p-2] != 0x0d || b[p-1] != 0x0a || b[p] != '.') {
			p++;
		  }
		  try {
			comment = new String(b, off, p-off, "SJIS");
		  } catch (java.io.UnsupportedEncodingException e) {
			comment = "This JavaVM don't support Shift-JIS character code.";
		  }
		  p++;
		}
		waittime=0;
		if ('0' <= b[p] && b[p] <= '9') {
		  while ('0' <= b[p] && b[p] <= '9') {
			waittime = waittime*10 + (b[p++] - '0');
		  }
		}
		else {
		  waittime = 0xFFFFFFFF;
		}
		while (b[p-2] != 0x0d || b[p-1] != 0x0a)
		  p++;
				
		while (b[p-2] != 0x0d || b[p-1] != 0x0a || b[p] != '.') {
		  while (b[p-1] != 0x0d || b[p] != 0x0a) {
			p++;
		  }
		  p++;
//		  files.addElement(new Boolean(true));
		  files++;
		}
		p++;
		for (int i=0; i<1; i++) {
		  while (b[p-2] != 0x0d || b[p-1] != 0x0a || b[p] != '.')
			p++;
		  p++;
		}
		
		while (b[p-2] != 0x0d || b[p-1] != 0x0a)
		  p++;
		
		byte bb[] = new byte[size - p];
		
		for (int i=0; i<bb.length; i++)  {
		  bb[i] = b[p+i];
		}
		
		MSC msc = new MSC(new ByteArrayInputStream(bb));
		/*
		if (mmjpoint != null && mmjpoint.size() > 0)
		  msc.setMMJPoint(mmjpoint);
		  */
		try {
		  env = msc.compile();
		} catch (ParseException e) {
		  e.printStackTrace();
		  throw(new IllegalMSCFormatException());
		}
		//		msc.setWaittime(waittime);
	  }

	  {
		int size, tsize, ci;
		int i,j,w,h;
		long lsize2;
		
		for (int x=0; x<files; x++) {
		  lsize2 = is.get32();
		  
		  is.read(buf, 0, 8);
		  lsize2 -= 8;
		  
		  if (buf[0] == 'N' && buf[1] == 'A' && buf[2] == 'K') {
			is.skip(32);
			tsize = is.get16();
			is.skip(tsize);
			lsize2 -= (34 + tsize);
			
			while (lsize2 > 0) {
			  ci = is.get8();
			  lsize2--;
			  
			  if (1 <= ci && ci <= 3) {
				tsize = is.get16();
				size = is.get16();
				i = is.get16();
				j = is.get16();
				w = is.get16() - i +1; if (w<0) { w *= -1; };
				h = is.get16() - j +1; if (h<0) { h *= -1; };
				is.skip(tsize);
				lsize2 -= (4 + tsize + 8 + size);
				byte b[] = new byte[size];
				is.read(b);
				vnak.addElement(new NAK(b,i,j,w,h));
			  }
			  else if (ci == 0) {
				tsize = is.get16();
				i = is.get16();        // ѥåֹ
				size = is.get16();     // RGBʬƤΥ
				is.skip(tsize);
				byte b[] = new byte[size];
				is.read(b);
				//				vpal.addElement(new PAL(b));
				int trans = NAK.TRANSPARENT;
				if (size < (trans+1)*3) {
				  byte bb[] = new byte[(trans+1)*3];
				  System.arraycopy(b,0,bb,0,b.length);
				  b = bb;
				}
				vpal.addElement(
				  new IndexColorModel(8, trans+1, b, 0, false, trans));

				lsize2 -= (6 + tsize + size);
			  }
			}
		  }	// end of NAK
		  else if (buf[0] == 'P' && buf[1] == 'K' && buf[2] == 'N') {
			is.skip(lsize2);
		  }
		  else {
			throw(new IllegalMSCFormatException("unknown data type"));
		  }
		}   // end of for(x)   
	  }
	}
	catch (IllegalMSCFormatException e) {
	  System.out.println("");
	  System.out.println(e.toString());
	  return;
	}

	nak = new NAK[vnak.size()];
	for (int i=0; i<nak.length; i++) {
	  nak[i] = (NAK)(vnak.elementAt(i));
	}
	/*
	cp = new ComPoints();
	for (Enumeration e = msc.mmjpoint.elements(); e.hasMoreElements();) {
	  int i = ((Integer) e.nextElement()).intValue();
	  nak[i].malloc();
	  cp.add(i, nak[i].pixel, new Dimension(nak[i].width, nak[i].height));
	}
	*/
	
	if (vpal.size() > 0) {
	  pal = new ColorModel[vpal.size()];
	  for (int i=0; i<pal.length; i++) {
		pal[i] = (ColorModel) vpal.elementAt(i);
	  }
	}
	else {
	  pal = new ColorModel[1];
	  pal[0] = ColorModel.getRGBdefault();
	}
	/*	
	pkn = new PKN[vpkn.size()];
	for (int i=0; i<pkn.length; i++) {
	  pkn[i] = (PKN)(vpkn.elementAt(i));
	}
	*/
  }
  
  public String getComment() {
	return comment;
  }

  public Environment getEnvironment() {
	return(env);
  }
  public NAK[] getNAKs() {
	return nak;
  }
  public ColorModel[] getPALs() {
	return pal;
  }

/*
  public MSC getMSC() {
	return msc;
  }
  public ComPoints getComPoints() {
	return cp;
  }
  public PKN[] getPKNs() {
	return pkn;
  }
  public int getVersion() {
	return ver;
  }
  */
}
