package mmj.mmasl;

import java.awt.image.*;
import java.util.*;

public class NAK implements ImageProducer {
  public static final int DEBUG = 0;
  public static final int TRANSPARENT = 255;

  ByteArray dat;
  int x0, y0, width, height;
  int pixel[];
  //  boolean trans[];
  ColorModel model;
  Hashtable properties;
  Vector consumer = new Vector();

  //  static final int vmax[] = { 64000,64000*2,64000*3,64000*4,64000*4+51200};

  static final int t1[] = {
	2,4,8,16,638,639,640,641,642,
	1278,1279,1280,1281,1282,2560,5120
  };

  public static final int WIDTH = 640;
  public static final int HEIGHT = 600;

  NAK(byte dat[]) {
	this(dat, 0,0, WIDTH, HEIGHT);
  }
  NAK(byte dat[], int x, int y, int w, int h) {
	this.dat = new ByteArray(dat);
	this.x0 = x;
	this.y0 = y;
	this.width = w;
	this.height= h;
  }

  //  public byte[] getPixels() { return pixel; }
  public int getWidth() { return width; }
  public int getHeight() { return height; }

  void setProperty(Hashtable t) {
	this.properties = t;
  }
  void setColorModel(ColorModel m) {
	this.model = m;
  }
  int getTransparentPixel() {
	return(TRANSPARENT);
  }

  void setPixel(int pt, int d) {
	int x = pt % WIDTH;
	int y = pt / WIDTH;
	if (x < x0 || x0+width <= x) return;
	if (y < y0 || y0+width <= y) return;
	int p = (x-x0) + (y-y0) * width;
	//	pixel[p] = (byte) ((d<0) ? d-256 : d);
	pixel[p] = d;
  }
  int getPixel(int pt) {
	int x = pt % WIDTH;
	int y = pt / WIDTH;
	if (x < x0 || x0+width <= x || y < y0 || y0+width <= y)
	  return(getTransparentPixel());

	int p = (x-x0) + (y-y0) * width;
	//	if (trans[p]) return 256;
	return pixel[p];
	//	return( (b<0) ? b+256 : b);
  }

  boolean using = false;
  void malloc() throws OutOfMemoryError {
	if (using) return;
	using = true;
	pixel = new int[width*height]; // throws OutOfMemoryError
  }
  void free() {
	if (using) return;
	pixel = null;
  }
  public void expand() {
	int com;
	int endcom=0;

	if (pixel == null) malloc();
//	dat.set(0);
	for (int i=0; i<pixel.length; i++)
	  pixel[i] = getTransparentPixel();
	int pt = 0;

	int cbuf[] = new int[32];
	for (int i=0; i<32; i++) {
	  cbuf[i] = dat.get8();
	}
	while ( (dat.eof() == false) && (pt < WIDTH * HEIGHT) ) {
	  com = dat.get8();
	  if (DEBUG != 0)
		System.out.println("com:" +com + "\t\t(x,y)=(" + pt%WIDTH + ", " + pt/WIDTH +")");
	  if (com<208) {
		int subcom = com % 13;
		int dp = 0;
	    switch (subcom) {
		case 8:
		case 9:
	      dp = dat.get4() * 2 + 9;
	      if (subcom == 9) dp++; 
	      break;
		case 10:
		case 11:
	      dp = dat.get8() * 2 + 41;
	      if (subcom == 11) dp++; 
	      break;
		case 12:
		  dp = dat.get16();
		  break;
		default: // 0-7
	      dp = subcom+1;
	      break;
		}
	    dp *= 2;
	    for (int i=0; i<dp; i++) {
	      setPixel(pt, getPixel(pt - t1[com/13]));
	      pt++;
	    }
		debug(pt);
	  }
	  else if (com < 238) { // 208-237
	    int dp = (((com - 208) / 15) == 0) ? 2 : 640;
	    int subcom = (com - 208) % 15;
	    if (subcom < 3) {
	      switch (subcom) {
	      case 0: // 208, 223
	        setPixel(pt,   getPixel(pt -dp));
	        setPixel(pt+1, getPixel(pt -dp));
	        break;
	      case 1: // 209, 224
	        setPixel(pt,   getPixel(pt -dp +1));
	        setPixel(pt+1, getPixel(pt -dp +1));
	        break;
	      case 2: // 210, 225
	        setPixel(pt,   getPixel(pt -dp +1));
	        setPixel(pt+1, getPixel(pt -dp));
	        break;
	      }
	    }
	    else {
		  int col;
		  switch (subcom % 3) {
		  case 0: // 211, 214, 217, 220, , 226, 229, 232, 235
	        col = cbuf[dat.get4()];
			break;
		  case 1: // 212, 215, 218, 221, , 227, 230, 233, 236
	        col = cbuf[dat.get4() + 16];
			break;
	      case 2: // 213, 216, 219, 222, , 228, 231, 234, 237
		  default:
	        col = dat.get8();
			break;
	      }
	      switch (subcom / 3) {
	      case 1: // 211-213, 226-231
	        setPixel(pt,   getPixel(pt -dp));
	        setPixel(pt+1, col);
	        break;
	      case 2: // 214-216, 229-231
	        setPixel(pt,   getPixel(pt -dp +1));
	        setPixel(pt+1, col);
	        break;
	      case 3: // 217-219, 232-234
	        setPixel(pt,   col);
	        setPixel(pt+1, getPixel(pt -dp +1));
	        break;
	      case 4: // 220-222, 235-237
	        setPixel(pt,   col);
	        setPixel(pt+1, getPixel(pt -dp));
	        break;
	      }
	    }
		pt += 2;
		debug(pt);
	  }
	  else { // 238 <= com
		int c1, c2;
		c1 = c2 = 0;

	    switch (com) {
		case 245:
		case 248:
		case 251: // from buffer 1
	      c1 = cbuf[dat.get4()];
	      break;

		case 246:
		case 249:
		case 252: // from buffer 2
	      c1 = cbuf[dat.get4()+16];
	      break;

		case 238:
		case 239:
		case 240:
		case 241: // to low and hi
	      int i = dat.get8();
	      c1 = (i & 0x0F);
	      c2 = (i >> 4);
	      if (com == 239 || com == 241) c1 += 16;
	      if (com == 240 || com == 241) c2 += 16;
	      c1 = cbuf[c1];
	      c2 = cbuf[c2];
	      break;

		case 243:
		case 247:
		case 250:
		case 253: // read next byte
	      c1 = dat.get8();
	      break;

		case 242:
		case 244: // read next word
	      c1 = dat.get16();
	      break;

		case 254:
		case 255:
		default:
	      break;
	    }

	    switch (com) {
	    case 238:
	    case 239:
	    case 240:
	    case 241:
	      setPixel(pt,   c1);
	      setPixel(pt+1, c2);
		  pt+=2;
		  debug(pt);
	      break;

	    case 242:
	      setPixel(pt,   c1 & 0xFF);
	      setPixel(pt+1, c1 >> 8);
		  pt+=2;
		  debug(pt);
	      break;

	    case 243:
	      c1 *= 2;
	    case 244:
	      pt += c1;
		  debug(pt);
	      break;

	    case 245:
	    case 246:
	    case 247:
	      setPixel(pt, c1);
		  pt+=2;
		  debug(pt);
	      break;

	    case 248:
	    case 249:
	    case 250:
	      setPixel(pt+1, c1);
		  pt+=2;
		  debug(pt);
	      break;

	    case 251:
	    case 252:
	    case 253:
	      setPixel(pt,   c1);
	      setPixel(pt+1, c1);
		  pt += 2;
		  debug(pt);
	      break;

	    case 254:
	      break;

	    case 255:
		  if (DEBUG != 0)
			System.out.println(endcom +"(" +(pt%WIDTH) +"," +(pt / WIDTH) +")");
	      if (endcom < 4) {
	        dat.setHalf(false);
			++endcom;
			pt = endcom * 100 * WIDTH; // perhaps...
			debug(pt);
	      } else 
	        dat.last();
	      break;
	    }
	  }	          
	}
	using = false;
  }

  /**
   * implements ImageProducer
   */
  public void requestTopDownLeftRightResend(ImageConsumer ic) {
	try {
	  ic.setDimensions(width, height);
	  ic.setProperties(properties);
	  ic.setColorModel(model);
	  ic.setHints(ImageConsumer.TOPDOWNLEFTRIGHT |
				  ImageConsumer.COMPLETESCANLINES |
				  ImageConsumer.SINGLEPASS |
				  ImageConsumer.SINGLEFRAME);
	  ic.setPixels(0,0,width,height, model,pixel, 0,width);
	  ic.imageComplete(ImageConsumer.STATICIMAGEDONE);
	} catch (Exception e) {
	  e.printStackTrace();
	  if (isConsumer(ic)) {
		ic.imageComplete(ImageConsumer.IMAGEERROR);
	  }
	}
  }
  public synchronized void startProduction(ImageConsumer ic) {
	addConsumer(ic);
  }
  public synchronized void addConsumer(ImageConsumer ic) {
	if (! consumer.contains(ic)) consumer.addElement(ic);
	for (Enumeration e=consumer.elements(); e.hasMoreElements();) {
	  requestTopDownLeftRightResend((ImageConsumer)e.nextElement());
	}
  }
  public synchronized boolean isConsumer(ImageConsumer ic) {
	return(consumer.contains(ic));
  }
  public synchronized void removeConsumer(ImageConsumer ic) {
	if (consumer.contains(ic)) consumer.removeElement(ic);
  }

  private void debug(int newpt) {
	if (DEBUG != 0)
	  System.out.println("  pt+=" +newpt);
  }
}
