package mmj.mmasl.msc;

import mmj.MMJRuntime;
import mmj.Expression;
import mmj.Environment;

public class ASTAssign extends ASTCommandStatement {
  public boolean isStableArgumentCount(int i) { return(i==2); }

  protected int getAssignValue(int i, int j) {
	return(j);
  }
  protected String getAssignSymbol() {
	return(":");
  }

  public int evaluate(Environment e, MMJRuntime r) {
	if (e == null) return 0;
	int i = children[0].evaluate(e, r);
	int j = children[1].evaluate(e, r);
	int ret = getAssignValue(e.getVariable(i), j);
	e.setVariable(i, ret);
	return(ret);
  }

  public String toString() {
	StringBuffer sb = new StringBuffer();
	sb.append("@");
	sb.append(children[0].toString());
	sb.append(" " + getAssignSymbol() + "= ");
	sb.append(children[1].toString());
	return(sb.toString());
  }
}
