package mmj.mmasl.msc;

import mmj.Expression;
import mmj.Environment;
import mmj.MMJRuntime;

public class ASTBlock extends SimpleNode {
  public ASTBlock(int id) {
    super(id);
  }

  public ASTBlock(MSC p, int id) {
    super(p, id);
  }

  public void jjtClose() {
	if (children == null || children.length == 0) {
	  children = new Node[1];
	  children[0] = new ASTNOP();
	}
	for (int i=0; i<children.length -1; i++)
	  children[i].connect(children[i+1]);
  }
  
  public int evaluate(Environment e, MMJRuntime r) {
	return(0);
  }

  public Expression next(Environment e) {
	if (children != null && children.length > 0) 
	  return(children[0]);
	else
	  return(nextBranch(e));
  }

  public String toString(String prefix) {
	StringBuffer sb = new StringBuffer();
	String prepre = (prefix.length() > INDENT.length())
	  ? prefix.substring(INDENT.length())
	  : "";
	sb.append(prepre +"{\n");
	prefix = prepre + INDENT;

	int len = (children == null) ? 0 : children.length;
	for (int i=0; i<children.length; i++) {
	  if (children[i] instanceof SimpleNode)
		sb.append(((SimpleNode)children[i]).toString(prefix));
	  else
		sb.append(prefix +children[i].toString());
	  sb.append("\n");
	}
	sb.append(prepre + "}");
	return(sb.toString());
  }
}
