package mmj.mmasl.msc;

import mmj.MMJRuntime;
import mmj.Environment;

public class ASTOperation extends FunctionalNode {
  public ASTOperation(int id) {
    super(id);
  }

  public ASTOperation(MSC p, int id) {
    super(p, id);
  }

  public boolean isStableArgumentCount(int i) { return(i==2); }

  Operation operation;
  public void setOperation(String s) {
	Operation op = Operation.getInstance(s);
	if (op == null) throw(new IllegalArgumentException());
	operation = op;
  }
  public void setOperation(Operation op) {
	if (op == null) throw(new IllegalArgumentException());
	operation = op;
  }
  public int evaluate(Environment p, MMJRuntime r) {
	int a = children[0].evaluate(p,r);
	int b = children[1].evaluate(p,r);
	return(operation.operate(a,b));
  }
  public String toString() {
	return(children[0].toString() + " " +
		   operation.toString() + " " +
		   children[1].toString());
  }
}
