package mmj.mmasl.msc;

import mmj.Expression;
import mmj.Environment;
import mmj.Constant;

public class ASTRepeat extends Loop {
  public ASTRepeat(int id) {
    super(id);
  }

  public ASTRepeat(MSC p, int id) {
    super(p, id);
  }

  Expression cond;
  public void setCondition(Expression e) {
	cond = e;
  }
  public void setInfinite() {
	setCondition(Constant.TRUE);
  }

  boolean first;
  public void preEvaluate(Environment e) { first = true; }
  protected void postEvaluate(Environment e) { first = false; }
  protected boolean contCheck(Environment e) {
	if (first) return true;
	else return(cond.evaluate(e,null) != 0);
  }
  public String toString() {
	return("do");
  }
  public String toString(String prefix) {
	StringBuffer sb = new StringBuffer();
	sb.append(prefix + "do\n");
	sb.append(super.toString(prefix));
	sb.append(prefix + "endwhile(");
	sb.append(cond.toString());
	sb.append(")\n");
	return(sb.toString());
  }
}
