package mmj.mmasl.msc;

import mmj.Expression;
import mmj.Environment;
import mmj.Constant;
import mmj.MMJRuntime;
import java.util.*;

public class ASTSwitch extends SimpleNode {
  public ASTSwitch(int id) {
    super(id);
  }

  public ASTSwitch(MSC p, int id) {
    super(p, id);
  }

  Hashtable table = new Hashtable();
  Vector condition = new Vector();
  public void addCase(Expression c, Expression s) {
	if (table.containsKey(c)) return;
	table.put(c, s);
	condition.addElement(c); // for order
	if (s instanceof Node) ((Node)s).jjtSetParent(this);
  }
  public void setDefault(Expression s) {
	addCase(Constant.TRUE, s);
  }

  /*
  public void jjtClose() {
	if (children == null) return;
	for (int i=0; i<children.length -1; i++) {
	  addStatement(children[i]);
	}
	if (statement.size() > condition.size())
	  condition.addElement(Constant.TRUE);
  }
  */

  int next;
  public int evaluate(Environment e, MMJRuntime r) {
	for (int i = 0; i<condition.size(); i++) {
	  Expression cond = (Expression) condition.elementAt(i);
	  if (cond.evaluate(e, null) != 0) {
		next = i;
		return(next);
	  }
	}
	next = -1;
	return(next);
  }
  public Expression next(Environment e) {
	if (0 <= next && next < condition.size()) {
	  Object cond = condition.elementAt(next);
	  return((Expression) table.get(cond));
	} else {
	  return(nextBranch(e));
	}
  }
  /*
  public Expression next(Environment e) {
	for (int i = 0; i<condition.size(); i++) {
	  Expression cond = (Expression) condition.elementAt(i);
	  if (cond.evaluate(e, null) != 0)
		return((Expression) table.get(cond));
	}
	return(nextBranch(e));
  }
  */

  public String toString(String prefix) {
	StringBuffer sb = new StringBuffer();
	for (int i=0; i<condition.size(); i++) {
	  if (i==0) sb.append(prefix);
	  else sb.append("\n" + prefix + "else ");
	  Object cond = condition.elementAt(i);
	  if (! cond.equals(Constant.TRUE)) {
		sb.append("if (" + cond + ") ");
	  }
	  sb.append("\n");
	  Object s = table.get(cond);
	  if (s instanceof SimpleNode) {
		sb.append(((SimpleNode)s).toString(prefix+INDENT));
	  } else {
		sb.append(prefix+INDENT +s);
	  }
	}
	return(sb.toString() + "\n");
  }
}
