package mmj.mmasl.msc;

public abstract class FunctionalNode extends SimpleNode {
  public FunctionalNode(int id) {
    super(id);
  }

  public FunctionalNode(MSC p, int id) {
    super(p, id);
  }

  public abstract boolean isStableArgumentCount(int i);

  public void jjtClose() {
	int argc = (children == null) ? 0 : children.length;
	if (! isStableArgumentCount(argc))
	  throw(new IllegalArgumentException());
  }

  public String getName() {
	return(super.toString());
  }
  public String toString() {
	StringBuffer sb = new StringBuffer(getName());
	sb.append("(");

	int length = (children == null) ? 0 : children.length;
	if (0 < length)
	  sb.append(children[0].toString());
	for (int i=1; i<length; i++)
	  sb.append(", " +children[i].toString());

	sb.append(")");
	return(sb.toString());
  }
}
