package mmj.mmasl.msc;

import mmj.MMJRuntime;
import mmj.Expression;
import mmj.Environment;

public abstract class Loop extends ASTBlock {
  public Loop(int id) {
    super(id);
  }

  public Loop(MSC p, int id) {
    super(p, id);
  }

  protected abstract void preEvaluate(Environment e);
  protected abstract void postEvaluate(Environment e);
  /**
   * You must not expect that contCheck() is called once a every loop.
   * It may be called 2 or more times a loop.
   */
  protected abstract boolean contCheck(Environment e);

  public int evaluate(Environment e, MMJRuntime r) {
	preEvaluate(e);
	return(contCheck(e) ? 1 : 0);
  }
  public Expression next(Environment e) {
	return((contCheck(e)) ? super.next(e) : super.nextBranch(e));
  }
  public Expression nextBranch(Environment e) {
	postEvaluate(e);
	return(next(e));
  }

  public String toString() {
	return("loop");
  }
  public String toString(String prefix) {
	StringBuffer sb = new StringBuffer();
	int len = (children == null) ? 0 : children.length;
	for (int i=0; i<len; i++) {
	  if (children[i] instanceof SimpleNode)
		sb.append(((SimpleNode) children[i]).toString(prefix+INDENT));
	  else
		sb.append(prefix+INDENT +children[i].toString());
	  sb.append("\n");
	}
	return(sb.toString());
  }
}
