package mmj.mmasl.msc;

abstract class MSCCommandFactory {
  static ASTCommandStatement create(String s) {
	if (false) return(null);
	else if (s.equals("=@")) return(new ASTAssign());
	else if (s.equals("+@")) return(new ASTAdd());
	else if (s.equals("-@")) return(new ASTSubtract());
	else if (s.equals("*@")) return(new ASTMultiply());
	else if (s.equals("/@")) return(new ASTDivide());
	else if (s.equals("%@")) return(new ASTModulus());
	else if (s.equals("&@")) return(new ASTAnd());
	else if (s.equals("|@")) return(new ASTOr());
	else if (s.equals("^@")) return(new ASTExclusiveOr());

	else if (s.equals("\\")) return(new ASTEnd());
	else if (s.equals("jmp")) return(new ASTJump());
	else if (s.equals("call")) return(new ASTCall());
	else if (s.equals("ret")) return(new ASTRet());
	else if (s.equals("delret")) return(new ASTDelRet());

	else if (s.equals("gmode")) return(new ASTGMode());
	else if (s.equals("wsize")) return(new ASTWSize());
	else if (s.equals("wmove")) return(new ASTWMove());
	else if (s.equals("d")) return(new ASTD());
	else if (s.equals("m")) return(new ASTM());
	else if (s.equals("box")) return(new ASTBox());
	else if (s.equals("pset")) return(new ASTPSet());
	else if (s.equals("point@")) return(new ASTPoint());
	else if (s.equals("psetw")) return(new ASTPSetW());
	else if (s.equals("pointw@")) return(new ASTPointW());
	else if (s.equals("disp")) return(new ASTDisp());
	else if (s.equals("cdisp")) return(new ASTCDisp());

	else if (s.equals("count")) return(new ASTCount());
	else if (s.equals("tc")) return(new ASTTC());
	else if (s.equals("t")) return(new ASTT());

	else if (s.equals("orm")) return(new UnsupportedCommand(s));
	else if (s.equals("zoom")) return(new UnsupportedCommand(s));
	else if (s.equals("pal")) return(new UnsupportedCommand(s));
	else if (s.equals("dpal")) return(new UnsupportedCommand(s));
	else if (s.equals("tone")) return(new UnsupportedCommand(s));
	else if (s.equals("ptone")) return(new UnsupportedCommand(s));

	else if (s.equals("pcm")) return(new UnsupportedCommand(s));
	else if (s.equals("pcml")) return(new UnsupportedCommand(s));
	else if (s.equals("pch")) return(new UnsupportedCommand(s));
	else if (s.equals("pwt")) return(new UnsupportedCommand(s));
	else if (s.equals("pst")) return(new UnsupportedCommand(s));
	else if (s.equals("rate")) return(new UnsupportedCommand(s));

	else if (s.equals("readpara")) return(new UnsupportedCommand(s));
	else if (s.equals("getpara@")) return(new UnsupportedCommand(s));

	else {
	  return(new UnknownCommand(s));
	}
  }
}
