package mmj.mmasl.msc;

public class Operation {
  public static final Operation ADDITIVE = new Operation(0);
  public static final Operation SUBTRACT = new Operation(1);
  public static final Operation MULTIPLY = new Operation(2);
  public static final Operation DIVISION = new Operation(3);
  public static final Operation MODULUS = new Operation(4);
  public static final Operation AND = new Operation(5);
  public static final Operation OR = new Operation(6);
  public static final Operation XOR = new Operation(7);

  public static final Operation EQ = new Operation(10);
  public static final Operation NE = new Operation(11);
  public static final Operation GT = new Operation(12);
  public static final Operation GE = new Operation(13);
  public static final Operation LT = new Operation(14);
  public static final Operation LE = new Operation(15);

  public static Operation getInstance(String op) {
	if (op.equals("+")) return ADDITIVE;
	else if (op.equals("-")) return SUBTRACT;
	else if (op.equals("*")) return MULTIPLY;
	else if (op.equals("/")) return DIVISION;
	else if (op.equals("%")) return MODULUS;
	else if (op.equals("&") || op.equals("and")) return AND;
	else if (op.equals("|") || op.equals("or")) return OR;
	else if (op.equals("^") || op.equals("xor")) return XOR;

	if (op.equals("=") || op.equals("==")) return EQ;
	else if (op.equals("!=") || op.equals("!")) return NE;
	else if (op.equals(">")) return GT;
	else if (op.equals(">=")) return GE;
	else if (op.equals("<")) return LT;
	else if (op.equals("<=")) return LE;
	else return null;
  }

  int id;
  private Operation(int i) {
	id = i;
  }
  private static int bool2int(boolean b) { return(b ? 1 : 0); }
  public int operate(int a, int b) {
	switch (id) {
	case 0: return(a + b);
	case 1: return(a - b);
	case 2: return(a * b);
	case 3: return(a / b);
	case 4: return(a % b);
	case 5: return(a & b);
	case 6: return(a | b);
	case 7: return(a ^ b);

	case 10: return(bool2int(a == b));
	case 11: return(bool2int(a != b));
	case 12: return(bool2int(a > b));
	case 13: return(bool2int(a >= b));
	case 14: return(bool2int(a < b));
	case 15: return(bool2int(a <= b));
	default: return(0);
	}
  }

  public String toString() {
	switch (id) {
	case 0: return("+");
	case 1: return("-");
	case 2: return("*");
	case 3: return("/");
	case 4: return("%");
	case 5: return("&");
	case 6: return("|");
	case 7: return("^");

	case 10: return("==");
	case 11: return("!=");
	case 12: return(">");
	case 13: return(">=");
	case 14: return("<");
	case 15: return("<=");
	default: return("<no op>");
	}
  }
}
